<template>
  <div v-if="user.enabled || !user">
    <section class="primary darken-4 mb-3 white--text py-5">
      <v-container>
        <div class="d-flex flex-column align-start flex-sm-row align-center">
          <v-avatar
              color="accent"
              rounded
              size="130"
              class="mr-5">
            <img alt="Avatar" :src="user.avatar">
          </v-avatar>
          <div class="py-3 text-center text-sm-left">
            <div class="text-h4">
              {{ user.firstName }} {{ user.lastName }}
            </div>
            <div class="text-h6">
              {{ user.title }}
            </div>
          </div>
        </div>
      </v-container>
    </section>
    <section>
      <v-container>
        <v-row>
          <h1 class="gray--text lighten-3 main-title">Voici la liste de vos cabinets :
          </h1>
        </v-row>

        <v-row>
          <v-col cols="12">
            <v-btn small color="primary" block class="py-5"
                   @click="updateModal.dialog = true; updateModal.addItem = true; updateModal.office = {}; updateModal.loading = false;">
              <v-icon class="mr-2" small>mdi-plus-circle</v-icon>
              Ajouter un cabinet
            </v-btn>
          </v-col>
        </v-row>

        <div v-show="officeIsLoading || waitingOffices.length > 0">
          <v-row>
            <v-col cols="12">
              <h3>Vos cabinets en attente</h3>
            </v-col>
          </v-row>

          <v-row>

            <v-col v-show="officeIsLoading" cols="12" sm="4" xl="3" v-for="n in 3" :key="'1-' + n">
              <v-skeleton-loader type="image, article"></v-skeleton-loader>
            </v-col>

            <v-col cols="12" sm="4" xl="3" v-for="(office, index) in waitingOffices" :key="index">
              <officeCard :office="office" :isCreator="office.creator.email === user.email"
                          :remove-modal="removeModal" :update-modal="updateModal" :pro-modal="proModal"/>
            </v-col>
          </v-row>
        </div>

        <div v-show="officeIsLoading || otherOffices.length > 0">
          <v-row>
            <v-col cols="12">
              <h3>Vos cabinets</h3>
            </v-col>
          </v-row>

          <v-row>

            <v-col v-show="officeIsLoading" cols="12" sm="4" xl="3" v-for="n in 3" :key="'2-' + n">
              <v-skeleton-loader type="image, article"></v-skeleton-loader>
            </v-col>

            <v-col cols="12" sm="4" xl="3" v-for="(office, index) in otherOffices" :key="index">
              <officeCard :office="office" :isCreator="office.creator.email === user.email"
                          :remove-modal="removeModal" :update-modal="updateModal" :pro-modal="proModal"/>
            </v-col>
          </v-row>
        </div>

        <v-dialog v-model="removeModal.dialog" max-width="500px">
          <v-card class="py-2">
            <v-card-title class="headline my-4 text-center">{{ removeModal.action.title }}</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="removeModal.dialog = false">Annuler</v-btn>
              <v-btn color="error" text @click="confirmRemoveOffice" :loading="removeModal.loading"
                     :disabled="removeModal.loading">Confirmer
              </v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <v-dialog v-model="updateModal.dialog" max-width="750px">
          <v-card class="pa-4">
            <v-card-title class="headline my-2 justify-center">
              {{ updateModal.addItem ? 'Ajouter un cabinet' : 'Modifier mon cabinet' }}
            </v-card-title>
            <v-form v-model="updateModal.isValid">
              <v-row>
                <v-col cols="12">
                  <v-text-field v-model="updateModal.office.name" required filled hide-details
                                :rules="[$utils.rules.required]"
                                type="text" label="Nom du cabinet"/>
                </v-col>
                <v-col cols="12">
                  <v-text-field v-model="updateModal.office.label" required filled hide-details
                                :rules="[$utils.rules.required]"
                                type="text" hint="Centre Urgentiste, Toiletteur..." label="Type de cabinet"/>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12">
                  <v-text-field v-model="updateModal.office.address" required filled hide-details
                                :rules="[$utils.rules.required]"
                                type="text" label="Adresse"/>
                </v-col>
                <v-col cols="12">
                  <v-text-field v-model="updateModal.office.city" required filled hide-details
                                :rules="[$utils.rules.required, $utils.rules.text]"
                                type="text" label="Ville"/>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-text-field v-model="updateModal.office.postalCode" required filled hide-details
                                :rules="[$utils.rules.required, $utils.rules.postalCode]"
                                type="text" :counter="5" label="Code postal"/>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-select v-model="updateModal.office.country" required filled hide-details
                            :rules="[$utils.rules.required]"
                            :items="contries" label="Pays"></v-select>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12" sm="6">
                  <v-text-field v-model="updateModal.office.phoneNumber" required filled hide-details
                                :counter="10"
                                :rules="[$utils.rules.required, $utils.rules.phoneNumber]"
                                type="text" label="Numéro de téléphone"/>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-text-field v-model="updateModal.office.faxNumber" required filled hide-details
                                type="text" label="Numéro de fax"/>
                </v-col>
                <v-col cols="12">
                  <v-text-field v-model="updateModal.office.email" required filled hide-details
                                :rules="[$utils.rules.required, $utils.rules.email]"
                                type="text" label="Email"/>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12">
                  <v-textarea name="input-7-1" filled v-model="updateModal.office.description" auto-grow hide-details
                              label="Description de votre cabinet"/>
                </v-col>
              </v-row>
            </v-form>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="secondary" text @click="updateModal.dialog = false">Annuler</v-btn>
              <v-btn color="primary darken-1" @click="confirmOffice()"
                     :loading="updateModal.loading" :disabled="updateModal.loading || ! updateModal.isValid">
                {{ updateModal.addItem ? 'Ajouter' : 'Modifier' }}
              </v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <v-dialog v-model="proModal.dialog" max-width="500px">
          <v-card class="py-2">
            <v-card-title class="headline my-4 justify-center">
              {{
                proModal.office.creator && proModal.office.creator.email === user.email ?
                    'Gestion du cabinet' : 'Aperçu du cabinet'
              }}
            </v-card-title>
            <v-list>

                            <v-list-item>
                <v-container>
                  <v-row>
                    <v-col cols="12">
                      <v-autocomplete
                        v-model="proModal.careToAdd"
                        :items="careTypesFound"
                        chips
                        label="Sélectionner des types de soin"
                        item-text="label"
                        item-value="id"
                        hide-no-data
                        return-object
                      >
                        <template v-slot:selection="data">
                          <v-chip
                            v-bind="data.attrs"
                            :input-value="data.selected"
                            @click="data.select"
                          >
                            {{ data.item.label }}
                          </v-chip>
                        </template>
                        <template v-slot:item="data">
                          <template>
                            <v-list-item-content>
                              <v-list-item-title v-html="data.item.label"></v-list-item-title>
                            </v-list-item-content>
                          </template>
                        </template>
                      </v-autocomplete>
                    </v-col>
                    <v-col cols="12">
                      <v-btn small color="primary" block class="py-5"
                            @click="addCareToPro" :loading="proModal.loadingButtonCare" :disabled="proModal.loadingButtonCare">
                        <v-icon class="mr-2" small>mdi-plus-circle</v-icon>
                        Ajouter un type de soin
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-container>
              </v-list-item>

              <v-list-item v-for="(care, ind) in currentCares" :key="ind">
                <div class="d-flex w-100 mb-4">
                  <div class="d-flex flex-column pl-4">
                    <div><b>{{ care.id }}</b></div>
                  </div>
                  <v-spacer></v-spacer>
                  <div class="d-flex flex-row">
                    <v-btn icon large color="error" @click="removeCareFromPro(care)">
                      <v-icon>mdi-close-circle</v-icon>
                    </v-btn>
                  </div>
                </div>
              </v-list-item>

              <v-list-item>
                <v-divider></v-divider>
              </v-list-item>

              <v-list-item v-if="proModal.office.creator && proModal.office.creator.email === user.email">
                <v-container>
                  <v-row>
                    <v-col cols="12">
                      <v-autocomplete
                        v-model="proModal.prosToAdd"
                        :items="proModal.prosFound"
                        :loading="proModal.loadingPros"
                        :search-input.sync="proModalSearch"
                        chips
                        label="Sélectionner des professionnels"
                        :no-data-text="proModal.fieldText"
                        item-text="name"
                        item-value="id"
                        multiple
                        return-object
                      >
                        <template v-slot:selection="data">
                          <v-chip
                            v-bind="data.attrs"
                            :input-value="data.selected"
                            close
                            @click="data.select"
                            @click:close="removeUserOnField(data.item)"
                          >
                            <v-avatar left>
                              <v-img :src="data.item.avatar"></v-img>
                            </v-avatar>
                            {{ data.item.name }}
                          </v-chip>
                        </template>
                        <template v-slot:item="data">
                          <template>
                            <v-list-item-avatar>
                              <img :src="data.item.avatar">
                            </v-list-item-avatar>
                            <v-list-item-content>
                              <v-list-item-title v-html="data.item.name"></v-list-item-title>
                              <v-list-item-subtitle v-html="data.item.email"></v-list-item-subtitle>
                            </v-list-item-content>
                          </template>
                        </template>
                      </v-autocomplete>
                    </v-col>
                    <v-col cols="12">
                      <v-btn small color="primary" block class="py-5"
                            @click="addProsToOffice" :loading="proModal.loadingButton" :disabled="proModal.loadingButton">
                        <v-icon class="mr-2" small>mdi-plus-circle</v-icon>
                        Ajouter un professionnel
                      </v-btn>
                    </v-col>
                  </v-row>
                </v-container>
              </v-list-item>

              <v-list-item v-for="(pro, index) in proModal.office.pros" :key="index">
                <div class="d-flex w-100 mb-4"
                     v-if="pro.email !== user.email || pro.email !== proModal.office.creator.email">
                  <v-avatar>
                    <v-img :alt="`${pro.firstName} avatar`" :src="pro.avatar"></v-img>
                  </v-avatar>
                  <div class="d-flex flex-column pl-4">
                    <div><b>{{ pro.firstName }}</b> <small>{{ pro.lastName }}</small></div>
                    <div>{{ pro.email }}</div>
                  </div>
                  <v-spacer></v-spacer>
                  <div class="d-flex flex-row" v-if="proModal.office.creator.email === user.email">
                    <v-btn icon large color="error" @click="removeProFromOffice(pro)">
                      <v-icon>mdi-close-circle</v-icon>
                    </v-btn>
                  </div>
                </div>
              </v-list-item>
            </v-list>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="proModal.dialog = false">Fermer</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

      </v-container>
    </section>

    <v-snackbar
        v-model="snackbar.enabled"
        :timeout="3000"
        :color="snackbar.color"
    >
      {{ snackbar.message }}
      <template v-slot:action="{ attrs }">
        <v-btn
            color="white"
            text
            v-bind="attrs"
            @click="snackbar.enabled = false"
        >
          Fermer
        </v-btn>
      </template>
    </v-snackbar>
  </div>
  <div v-else>
    <section>
      <v-container>
        <v-row justify="center">
          <h1 class="gray--text lighten-3 main-title">Votre compte doit être confirmé avant de pouvoir gérer vos
            cabinets</h1>
        </v-row>

        <v-row justify="center">
          <v-col cols="4">
            <router-link class="text-decoration-none" :to="{name: 'ConfirmationRegistration'}">
              <v-btn small color="primary" block class="py-5">
                <v-icon class="mr-2" small>mdi-account-check</v-icon>
                Confirmer mon compte
              </v-btn>
            </router-link>
          </v-col>
        </v-row>
      </v-container>
    </section>
  </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';
import OfficeCard from "@/components/OfficeCard";

export default {
  name: 'Professional',
  components: {OfficeCard},
  data() {
    return {
      snackbar: {
        enabled: false,
        message: '',
        color: 'success'
      },
      contries: [
        {text: 'France', value: 'FR'},
        {text: 'Suisse', value: 'SW'},
        {text: 'Belgique', value: 'BL'},
      ],

      removeModal: {
        office: null,
        dialog: false,
        loading: false,
        action: '',
        actions: {
          delete: {title: 'Supprimer le cabinet ?', value: 'delete'},
          quit: {title: 'Quitter le cabinet ?', value: 'quit'},
          cancel: {title: 'Annuler la demande de création du cabinet ?', value: 'cancel'},
        },
      },
      updateModal: {
        addItem: false,
        isValid: null,
        office: {},
        officeCache: {},
        dialog: false,
        loading: false,
      },
      proModal: {
        dialog: false,
        office: {},
        prosFound: [],
        prosToAdd: {},
        loadingButton: false,
        loadingPros: false,
        fieldText: 'Merci de saisir un nom ou un email',
        careToAdd: [],
        loadingButtonCare: false,
      },

      officeIsLoading: true,
      proModalSearch: '',
    }
  },
  computed: {
    ...mapGetters(['user', 'getCrudError', 'offices', 'officesOnWaiting', 'officesOnPlaced', 'careTypes', 'getCurrentCares']),
    waitingOffices() {
      return this.officesOnWaiting;
    },
    otherOffices() {
      return this.officesOnPlaced;
    },
    careTypesFound() {
      return this.careTypes;
    },
    currentCares() {
      return this.getCurrentCares;
    },
  },
  methods: {
    ...mapActions(['loadCurrentUser', 'loadOfficesByPro', 'deleteOffice', 'addOffice', 'updateOffice', 'loadCareTypes', 'addCare', 'loadCaresByIdCurrentUserPro', 'deleteCare']),
    confirmOffice() {
      this.updateModal.addItem ? this.confirmAddOffice() : this.confirmUpdateOffice();
    },
    confirmRemoveOffice() {
      let office = this.removeModal.office
      this.removeModal.loading = true;

      this.deleteOffice(office.id).then(() => {
        const index = this.offices.indexOf(office);
        if (index > -1) {
          this.offices.splice(index, 1);
        }

        this.displaySuccess("L'établissement a été supprimé avec succès")
      }).catch((error) => {
        this.displayError(error);
      }).finally(() => {
        this.removeModal.dialog = false;
        this.removeModal.loading = false;
      });
    },
    confirmUpdateOffice() {
      let office = this.updateModal.office;
      let officeCache = this.updateModal.officeCache;
      this.updateModal.loading = true;
      let dataChanged = this.$utils.getChanges(officeCache, office);

      if (!this.$utils.isEmptyObject(dataChanged)) {
        dataChanged.id = office.id;
        this.updateOffice(dataChanged).then(() => {
          this.displaySuccess('Le cabinet a été mis à jour');
        }).catch((error) => {
          this.displayError(error)
        }).finally(() => {
          this.updateModal.dialog = false
          this.updateModal.loading = false;
        });
      }
    },

    displayError(message) {
      this.snackbar.message = message;
      this.snackbar.enabled = true;
      this.snackbar.color = 'error'
    },

    displaySuccess(message, color = 'success') {
      this.snackbar.message = message;
      this.snackbar.enabled = true;
      this.snackbar.color = color;
    },

    confirmAddOffice() {
      let office = this.updateModal.office;
      this.updateModal.loading = true;
      office.creator = `/api/users/${this.user.id}`;

      this.addOffice(office).then(() => {
        this.displaySuccess("Le nouveau cabinet a été ajouté, il sera vérifié sous peu par l'équipe Vetvite", 'orange')
      }).catch((error) => {
        this.newOffice.creator = '';
        this.displayError(error);
      }).finally(() => {
        this.updateModal.dialog = false
        this.updateModal.loading = false;
      });
    },
    addProsToOffice() {
      let office = this.proModal.office;
      this.proModal.loadingButton = true;
      let pros = office.pros.map(pro => {
        return pro['@id'];
      });

      this.proModal.prosToAdd.forEach(pro => {
        pros.push(pro.uri);
      });

      const dataChanged = {
        id: office.id,
        pros: pros.filter((a, b) => pros.indexOf(a) === b)
      }

      this.updateOffice(dataChanged)
          .then(async () => {

            this.displaySuccess('Le cabinet a été mis à jour');

            this.proModal.prosToAdd = [];
            await this.loadOfficesByPro(`/api/users/${this.user.id}`);
            this.proModal.office = this.offices.find(officeFetch => officeFetch.id === office.id);
          })
          .catch((error) => {
            this.displayError(error);
          }).then(() => {
        this.proModal.loadingButton = false;
      });
    },
    async searchPro(searchQuery) {
      this.proModal.fieldText = 'Recherche en cours..';
      await this.$apiRest.get('/users?roles=PRO&search=' + searchQuery + '&itemsPerPage=20')
          .then(res => {
            const pros = res.data['hydra:member'];
            if (pros.length > 0) {
              this.proModal.prosFound = pros.map(pro => {
                if (pro.email !== this.user.email) {
                  return {
                    uri: pro['@id'],
                    id: pro.id,
                    name: pro.firstName + ' ' + pro.lastName,
                    email: pro.email,
                    avatar: pro.avatar,
                  };
                }
              }).filter(pro => pro);
            }
            this.proModal.fieldText = 'Aucun professionnel n\'a été trouvé';
          }).catch(() => {
            this.proModal.fieldText = 'Une erreur est survenue';
          });
    },
    removeUserOnField(item) {
      const index = this.proModal.prosToAdd.indexOf(item);
      if (index >= 0) this.proModal.prosToAdd.splice(index, 1);
    },
    removeCareOnField(item) {
        const index = this.proModal.careToAdd.indexOf(item);
        if (index >= 0) this.proModal.careToAdd.splice(index, 1);
    },
    removeProFromOffice(pro) {
      let office = this.proModal.office;
      let prosCached = office.pros.map(proFetch => {
        return proFetch['@id'];
      });

      prosCached = prosCached.filter(proFetch => proFetch !== pro["@id"])

      const dataChanged = {
        id: office.id,
        pros: prosCached
      }

      this.updateOffice(dataChanged)
          .then(() => {
            office.pros = office.pros.filter(proFetch => proFetch !== pro);
            this.displaySuccess('Le cabinet a été mis à jour')
          })
          .catch((error) => {
            this.displayError(error);
          });
    },
    removeCareFromPro(care) {
      console.log(care)
      this.deleteCare(care.id)
          .then(() => {
            this.displaySuccess('Le type de soin a été supprimé avec succès')
            const index = this.getCurrentCares.indexOf(care);
            if (index > -1) {
              this.getCurrentCares.splice(index, 1);
            }
          })
          .catch((error) => {
            this.displayError(error)
          });
    },
    addCareToPro() {
      let office = this.proModal.office;
      this.proModal.loadingButtonCare = true;

      const care = {
            pro: `/api/users/${this.user.id}`,
            office: office['@id'],
            type: this.proModal.careToAdd.id,
            position: 1
          };

      this.addCare(care)
          .then(() => {
            this.proModal.loadingButtonCare = false;
            this.displaySuccess(`Le soin ${this.proModal.careToAdd.label} a été ajouté au cabinet`)
          })
          .catch((error) => {
            this.displayError(error)
            this.proModal.loadingButtonCare = false;
          });
    }
  },
  async mounted() {
    await this.loadCurrentUser(localStorage.getItem('token'));
    await this.loadOfficesByPro(`/api/users/${this.user.id}`).then(() => this.officeIsLoading = false);
    await this.loadCareTypes();
    await this.loadCaresByIdCurrentUserPro(this.user.id);
  },
  watch: {
    proModalSearch(value) {
      if (!value) {
        return;
      }
      this.searchPro(value);
    }
  }
}
</script>